SystemOrganization addCategory: #'Xenon-Tests'!
SystemOrganization addCategory: #'Xenon-Tests-Scenarios'!

TestCase subclass: #CLiteralValueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!CLiteralValueTest commentStamp: 'BernardoContreras 4/11/2012 19:47' prior: 0!
To test the translation of objects to a C literal value.
!

!CLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 19:49'!
testFalseTranslateToZero
	self assert: '0' equals: false asCLiteralValue! !

!CLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 20:18'!
testNilTranslateToNull
	self assert: 'null' equals: nil asCLiteralValue! !

!CLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 00:17'!
testStringTranslateToQuotedString
	| expected actual |
	expected := '"' , 'aString' , '"'.
	actual := 'aString' asCLiteralValue.
	self assert: expected equals: actual! !

!CLiteralValueTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 19:51'!
testTrueTranslateToZero
	self assert: '1' equals: true asCLiteralValue! !

TestCase subclass: #XeAbstractTest
	instanceVariableNames: 'cg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeAbstractTest methodsFor: 'convenience' stamp: 'BernardoContreras 4/11/2012 02:23'!
assertTranslationOf: aClass 
	" assert expected equals the translation of aClass"
	| expectedString actualString |
	cg addClass: aClass.
	actualString := cg codeString.
	expectedString := aClass expected contents.
	self assert: expectedString = actualString description: 'XeDiffBuilder openFor: ', aClass asString.
	! !

!XeAbstractTest methodsFor: 'running' stamp: 'BernardoContreras 4/11/2012 02:23'!
setUp
	cg := XeCodeGenerator new! !

XeAbstractTest subclass: #XeTranslateFunctionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateFunctionTest commentStamp: 'BernardoContreras 4/5/2012 15:12' prior: 0!
To test the translation of functions
!

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/12/2012 22:49'!
testTranslateFunctionCallAnotherFunction
	self assertTranslationOf: XeFunctionCallAnotherFunctionScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:23'!
testTranslateFunctionCallAnotherFunctionWithTwoArguments
	self assertTranslationOf: XeFunctionCallAnotherFunctionWithTwoArgumentsScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:25'!
testTranslateFunctionThatReturnsZero
	self assertTranslationOf: XeFunctionThatReturnsZeroScenario! !

!XeTranslateFunctionTest methodsFor: 'testing errors' stamp: 'BernardoContreras 4/15/2012 01:30'!
testTranslateFunctionWhenItHasManyReturnTypes
	self should: [ cg addClass: XeFunctionThatHasManyReturnTypeScenario ] raise: XeTooManyReturnTypesError! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:27'!
testTranslateFunctionWhenReturnTypeIsDefault
	self assertTranslationOf: XeFunctionWithDefaultReturnTypeScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:29'!
testTranslateFunctionWhenReturnTypeIsInteger
	self assertTranslationOf: XeFunctionWhenReturnTypeIsIntegerScenario! !

!XeTranslateFunctionTest methodsFor: 'testing errors' stamp: 'BernardoContreras 4/3/2012 21:43'!
testTranslateFunctionWhenReturnTypeIsUnknown
	cg addClass: XeFunctionWhenReturnTypeIsUnknownScenario.
	self should: [ cg codeString ] raise: XeTypeNotFoundError! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:34'!
testTranslateFunctionWithOneArgument
	self assertTranslationOf: XeFunctionWithOneArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:41'!
testTranslateFunctionWithOneIntegerArgument
	self assertTranslationOf: XeFunctionWithOneIntegerArgumentScenario! !

!XeTranslateFunctionTest methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:43'!
testTranslateFunctionWithTwoArguments
	self assertTranslationOf: XeFunctionWithTwoArgumentsScenario! !

XeAbstractTest subclass: #XeTranslateIfStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateIfStatementTest commentStamp: 'BernardoContreras 4/11/2012 02:33' prior: 0!
To test the translation of the if statement!

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/12/2012 20:48'!
testTranslateIfTrueStatement
	self assertTranslationOf: XeIfTrueScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 03:21'!
testTranslateIfTrueStatementReturnTypeInteger
	self assertTranslationOf: XeIfTrueReturnTypeIntegerScenario! !

!XeTranslateIfStatementTest methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 04:40'!
testTranslateNestedIfTrueStatement
	self assertTranslationOf: XeIfTrueNestedScenario ! !

Object subclass: #XeDiffBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeDiffBuilder commentStamp: 'BernardoContreras 4/11/2012 01:11' prior: 0!
To show you the diff between what it is expected and the actual translation.!

!XeDiffBuilder class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/11/2012 01:19'!
openFor: aClassScenario
 	| cg expectedString actualString diff |
	cg := XeCodeGenerator new.
	cg addClass: aClassScenario.
	actualString := cg codeString.
	expectedString := aClassScenario expected contents.
	diff := (StringHolder new textContents: (TextDiffBuilder buildDisplayPatchFrom: actualString to: expectedString)).
	expectedString = actualString 
		ifTrue: [	diff openLabel: aClassScenario asString, ' works!!'. ] 
		ifFalse: [ diff openLabel: aClassScenario asString, ' expected in green. actual in red'. ]			
	
! !

Object subclass: #XeExpected
	instanceVariableNames: 'stream indentationLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeExpected commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
To describe what it is expected as a result of the translation.
!

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 02:57'!
<< aCollection
	stream tab: indentationLevel.
	stream
		nextPutAll: aCollection;
		cr! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 03:05'!
contents
	^ stream contents! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/7/2012 05:08'!
functionPrototypesComment
	self << '/*** Function Prototypes ***/'! !

!XeExpected methodsFor: 'accessing' stamp: 'BernardoContreras 4/14/2012 03:00'!
indentation: aNumber
	indentationLevel := aNumber! !

!XeExpected methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/14/2012 02:55'!
initialize
	stream := WriteStream on: (String new: 1000).
	indentationLevel := 0! !

!XeExpected methodsFor: 'printing' stamp: 'BernardoContreras 4/7/2012 04:00'!
printOn: aStream
	aStream nextPutAll: 'expects '.
	aStream
		nextPut: $[;
		cr.
	aStream nextPutAll: stream contents.
	aStream nextPut: $]! !

Object subclass: #XeFunctionCallAnotherFunctionScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionCallAnotherFunctionScenario commentStamp: 'BernardoContreras 4/8/2012 00:40' prior: 0!
A function call another function.
!

!XeFunctionCallAnotherFunctionScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:09'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int bar(int y);'.
	expected << 'int foo(int x);'.
	expected << 'int bar(int y){'.
	expected indentation: 1.
	expected << 'return y + 1;'.
	expected indentation: 0.
	expected << '}'.
	expected << 'int foo(int x){'.
	expected indentation: 1.
	expected << 'return bar(x);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeFunctionCallAnotherFunctionScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/8/2012 00:42'!
bar: y
	<returnType: #int>
	<var: #y type: #int>
	^ y + 1! !

!XeFunctionCallAnotherFunctionScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/8/2012 00:41'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	^ self bar: x! !

Object subclass: #XeFunctionCallAnotherFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:08'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int barand(int z, int y);'.
	expected << 'int foo(int x);'.
	expected << 'int barand(int z, int y){'.
	expected indentation: 1.
	expected << 'return y + z;'.
	expected indentation: 0.
	expected << '}'.
	expected << 'int foo(int x){'.
	expected indentation: 1.
	expected << 'return barand(x, 5);'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/9/2012 04:18'!
bar: z and: y
	<returnType: #int>
	<var: #z type: #int>
	<var: #y type: #int>
	^ y + z! !

!XeFunctionCallAnotherFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/9/2012 04:19'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	^ self bar: x and: 5! !

Object subclass: #XeFunctionThatHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionThatHasManyReturnTypeScenario commentStamp: 'BernardoContreras 4/7/2012 20:19' prior: 0!
A function that has many return types.
!

!XeFunctionThatHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
	<returnType: #void>
! !

Object subclass: #XeFunctionThatReturnsZeroScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionThatReturnsZeroScenario commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
A function that returns zero
!

!XeFunctionThatReturnsZeroScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:06'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'return 0;'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeFunctionThatReturnsZeroScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 18:49'!
foo
	<returnType: #int>
	^ 0
		
! !

Object subclass: #XeFunctionWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWhenReturnTypeIsIntegerScenario commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
A function when return type is integer.
!

!XeFunctionWhenReturnTypeIsIntegerScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:28'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected << '}'.
	^ expected! !

!XeFunctionWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #int>
! !

Object subclass: #XeFunctionWhenReturnTypeIsUnknownScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWhenReturnTypeIsUnknownScenario commentStamp: 'BernardoContreras 4/7/2012 20:23' prior: 0!
A function that has an unknown return type.
!

!XeFunctionWhenReturnTypeIsUnknownScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
	<returnType: #unknown>
! !

Object subclass: #XeFunctionWithDefaultReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithDefaultReturnTypeScenario commentStamp: 'BernardoContreras 4/5/2012 15:19' prior: 0!
A function with a default return type.
!

!XeFunctionWithDefaultReturnTypeScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:27'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'sqInt foo(void);'.
	expected << 'sqInt foo(void){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithDefaultReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/25/2012 00:25'!
foo
! !

Object subclass: #XeFunctionWithOneArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithOneArgumentScenario commentStamp: 'BernardoContreras 4/5/2012 15:24' prior: 0!
A function with one argument.
!

!XeFunctionWithOneArgumentScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/13/2012 00:16'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(sqInt x);'.
	expected << 'int foo(sqInt x){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithOneArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/2/2012 01:57'!
foo: x
	<returnType: #int>
! !

Object subclass: #XeFunctionWithOneIntegerArgumentScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithOneIntegerArgumentScenario commentStamp: 'BernardoContreras 4/5/2012 17:06' prior: 0!
A function with one integer argument.
!

!XeFunctionWithOneIntegerArgumentScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:41'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(int x);'.
	expected << 'int foo(int x){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithOneIntegerArgumentScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/5/2012 16:05'!
foo: x
	<returnType: #int>
	<var: #x type: #int>
	! !

Object subclass: #XeFunctionWithTwoArgumentsScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeFunctionWithTwoArgumentsScenario commentStamp: 'BernardoContreras 4/7/2012 20:20' prior: 0!
A function with two arguments.
!

!XeFunctionWithTwoArgumentsScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/11/2012 01:47'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int fooand(sqInt x, sqInt y);'.
	expected << 'int fooand(sqInt x, sqInt y){'.
	expected << '}'.
	^ expected! !

!XeFunctionWithTwoArgumentsScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/13/2012 00:15'!
foo: x and: y
	<returnType: #int>
	! !

Object subclass: #XeIfTrueNestedScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfTrueNestedScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:03'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'if (1){'.
	expected indentation: 2.
	expected << 'if (0){'.
	expected indentation: 3.
	expected << 'return 30;'.
	expected indentation: 2.
	expected << '}'.
	expected indentation: 1.
	expected << '}'.
	expected << 'return 20;'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfTrueNestedScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/13/2012 04:38'!
foo
	<returnType: #int>
	true
		ifTrue: [ 
			false
				ifTrue: [ ^ 30 ] ].
	^ 20! !

Object subclass: #XeIfTrueReturnTypeIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfTrueReturnTypeIntegerScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 02:59'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'int foo(void);'.
	expected << 'int foo(void){'.
	expected indentation: 1.
	expected << 'if (1){'.
	expected indentation: 2.
	expected << 'return 30;'.
	expected indentation: 1.
	expected << '}'.
	expected << 'return 20;'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfTrueReturnTypeIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/13/2012 03:18'!
foo
	<returnType: #int>
	true
		ifTrue: [ ^ 30 ].
	^ 20! !

Object subclass: #XeIfTrueScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests-Scenarios'!

!XeIfTrueScenario commentStamp: 'BernardoContreras 4/11/2012 02:51' prior: 0!
An IfTrue Statement!

!XeIfTrueScenario class methodsFor: 'testing' stamp: 'BernardoContreras 4/14/2012 03:10'!
expected
	| expected |
	expected := XeExpected new.
	expected functionPrototypesComment.
	expected << 'void foo(void);'.
	expected << 'void foo(void){'.
	expected indentation: 1.
	expected << 'if (1){'.
	expected indentation: 2.
	expected << '0;'.
	expected indentation: 1.
	expected << '}'.
	expected << 'return;'.
	expected indentation: 0.
	expected << '}'.
	^ expected! !

!XeIfTrueScenario methodsFor: 'c code' stamp: 'BernardoContreras 4/13/2012 00:15'!
foo
	<returnType: #void>
	^ true
		ifTrue: [ 0 ]! !
